# Get the OS logs into a state suitable for display on the system

# See if the user specified which logs to get.  If not, default
# to the message logs.
if ($argument eq "")
    {
    $argument = "messages";
    }


# List the files, which are already ordered by name
my(@files) = qx(ls -1 /var/log/$argument*);
chomp(@files);
my($file);


my($MAX_RETURNED_LOG_ENTRIES) = 500;
my(@log_entries) = ();
my($truncated) = 0;
foreach $file (@files)
    {
    my(@local_log_entries) = ();

    if ($file =~ /.gz$/)
	{
	next if (!open(LOGFILE, "zcat $file |"));
	}
    else
	{
	next if (!open(LOGFILE, "<$file"));
	}

    # Process the logfile
    while (<LOGFILE>)
	{
	# add the new entry, in front of others from this log file (as it is more recent)
	unshift(@local_log_entries, $_);
	}

    close(LOGFILE);

    # Add these entries after the entries from other log files (as they were chronologically earlier)
    push(@log_entries, @local_log_entries);

    if ($#log_entries >= $MAX_RETURNED_LOG_ENTRIES)
	{
	$truncated = 1;
	last;
	}
    }


my($index) = 0;
my($end_index) = $#log_entries + 1;
if ($truncated)
    {
    print "Event list truncated at $MAX_RETURNED_LOG_ENTRIES entries.\n\n";
    $end_index = $MAX_RETURNED_LOG_ENTRIES;
    }

for ($index = 0; $index <= $end_index; $index++)
    {
    print $log_entries[$index];
    }

exit(0);
