my($debug) = 0;

my(@connections) = qx(netstat -tn);
chomp(@connections);

my($local_ip_prefix);

$local_ip_prefix = qx(ifconfig eth0 | grep 'inet addr:');
$local_ip_prefix =~ m/ +inet addr:([0-9]+.[0-9]+)/;
$local_ip_prefix = $1;

print "Local prefix is \"$local_ip_prefix\".\n" if ($debug);

my($connection);
my(@remote_connections) = ();
foreach $connection (@connections)
    {
    next if ($connection !~ /^tcp/);	# pitch header lines

    my($protocol, $rcvq, $sendq, $localaddr, $remoteaddr, $state) = split(' ', $connection);
    print "Line was $protocol -- $rcvq -- $sendq -- $localaddr -- $remoteaddr -- $state.\n" if ($debug);

    # Skip cluster internal connections and loopback connections (machine to itself)
    next if ($remoteaddr =~ /^\Q$local_ip_prefix\E/);
    next if ($remoteaddr =~ /^\Q127.0.0.1\E/);

    my($remotesystem, $remoteport) = split(':', $remoteaddr);
    my($line) = sprintf("%15s     %6s", $remotesystem, $remoteport);
    print "Adding system $remotesystem:$remoteport.\n" if ($debug);

    push(@remote_connections, $line);
    }

if ($#remote_connections > -1)
    {
    printf("Found %d remotely connected systems.\n", $#remote_connections + 1);
    printf("%15s     %6s\n", "System IP", "Port");
    print join("\n", @remote_connections), "\n";
    }
else
    {
    printf("No remotely connected systems.\n");
    }

exit 0;
