#
# lookup_nics()
#
# 06-12-2003	use FPnic to get nic info
# 06-17-2003	backwards issues
#

sub lookup_nics
{
	my ($iface) = @_;
	
	#
    # get nic configuration
	#
	if (-e '/sbin/FPnic')
	{
		$info = qx(/sbin/FPnic ${iface});
		chomp($info);
	    ($iface, $state, $speed, $link) = split(':', $info);
	} else {
		$info = qx(/sbin/mii-tool ${iface});
		chomp($info);
		
		($ignore, $config) = split(':', $info);
        if ($config =~ /no link/)
        {
           $speed = "";
           $link = $config;
           $link =~ s/^ *//;
        } else {
           ($speed, $link) = split(',', $config);
           $speed =~ s/ *negotiated *//;
           $link =~ s/^ *//;
        }
	}
	
	my(@ifconfig) = qx(ifconfig $iface);
	chomp(@ifconfig);
	my($ifconfig) = join("#", @ifconfig);
	$ifconfig =~ m/inet addr:([0-9.]*)/;
	my($inet_addr) = $1;
	my($up) = "DOWN";
	$up = "UP" if ($ifconfig =~ m/# {10}UP /);

	print "$iface: $inet_addr, $up, $speed, $link\n";
}

#
# main()
#
lookup_nics('eth0');
lookup_nics('eth1');
lookup_nics('eth2');
