my(@arguments) = split(' ', $argument);
unshift(@arguments, "/bin/ps");

pipe READER, WRITER;

my($pid) = fork();
if (!defined($pid))
    {
    print "Unable to create child process.\n";
    exit 1;
    }
elsif ($pid == 0)  # The child
    {
    if (!open(STDOUT, ">&WRITER"))  # write to the pipe
	    {
    	print WRITER "Unable to perform ps command - no stdout.\n";
    	exit 1;
	    }
    
    if (!open(STDERR, ">&WRITER"))  # errors to the pipe
        {
        print WRITER "Unable to perform ps command - no stderr.\n";
        exit 1;
        }
        
    close(STDIN);  # no need for input
    close(WRITER); # no more need for this FD to reference the pipe
    
#    print STDOUT "Running " . join(" - ", @arguments) . "\n";  # temp debug
    exec @arguments;  # run ps directly
    }
else		# parent
    {
    close(WRITER);
    
    my(@results) = <READER>;
    close(READER);

	print join("", @results);
    }

exit 0;
