#
# fp_transfer_directory [directory=] [filter=] [recursive=]
#
# if arg recursive is "true" we'll dive in to subdirectories.
#
# abeloos_ivo@emc.com
#

#
# make sure sensible defaults are used
#
if (!defined(${default_directory}))
{
        ${default_directory} = "/home/filepool/FP/Logfiles";
}
if (!defined(${default_filter}))
{
        ${default_filter} = "";
}
if (!defined(${default_recursive}))
{
        ${default_recursive} = "false";
}

#
# default configuration
#
%configuration = (
        directory       => ${default_directory},
        filter          => ${default_filter},
        recursive       => ${default_recursive}
);

#
# command line arguments
#
for ($i=0;$i<=$#ARGV;$i++) {
        foreach $key (keys %configuration) {
                if ($ARGV[$i] =~ /(.*)\=(.*)/) {
                        if ($1 eq $key) {
                                $configuration{$key} = $2;
                        }
                }
        }
}

#
# get the directory listing
#


read_directory($configuration{"directory"});


sub read_directory {

        my $directory = shift;
        if (-d $directory)
        {
                my $filter = $configuration{"filter"};
                local *LOGFILES;
                my $result = opendir(LOGFILES, $directory);
                if ($result)
                {
                        my @files = readdir(LOGFILES);
                        foreach $file (@files)
                        {
                                if (($file ne ".") && ($file ne ".."))
                                {
                                        if (-d $directory . "/" . $file)
                                        {
                                                if ($configuration{"recursive"} eq "true")
                                                {
                                                        read_directory($directory . "/" . $file);
                                                }
                                        } else {
                                                if (length($filter) > 0)
                                                {
                                                        if ($file =~ m/${filter}/g)
                                                        {
                                                                print STDOUT $directory . "/" . $file . "\n";
                                                        }
                                                } else {
                                                        print STDOUT $directory . "/" . $file . "\n";
                                                }
                                        }
                                }
                        }
                        closedir(LOGFILES);
                }
        }
}
