#
# fp_transfer_split [file=] 
#
# abeloos_ivo@emc.com
#

use POSIX;

#
# make sure sensible defaults are used
#
if (!defined(${default_file}))
{
	${default_file} = "";
}
if (!defined(${default_split_size}))
{
	${default_split_size} = 1024;
}

#
# default configuration
#
%configuration = (
	file		=> ${default_file},
	split_size	=> ${default_split_size}
);

#
# command line arguments
#
for ($i=0;$i<=$#ARGV;$i++) {
	foreach $key (keys %configuration) {
		if ($ARGV[$i] =~ /(.*)\=(.*)/) {
			if ($1 eq $key) {
				$configuration{$key} = $2;
			}
		}
	}
}

#
# sanity checks
#
my($number_splits) = 0;
if ($configuration{"split_size"} > 0)
{
	#
	# return the number of splits needed
	#
	if (-e $configuration{"file"})
	{
		my $split_size	= ceil($configuration{"split_size"});

		my $result = open(HANDLE, $configuration{"file"}); 
		if ($result != 0)
		{
			my @stats	= stat(HANDLE);
			if ($stats[7] > 0)
			{
				my $splits = $stats[7] / $split_size;
				$number_splits = ceil($splits);
			}
			close(HANDLE);
		}
	}
}

print STDOUT $number_splits;
