#
# node_status_cml.pl
#
# 05-23-2002 Rama Chivakula
# 05-27-2002 Ivo Abeloos
# 06-28-2002 Mark O'Connell, Ivo Abeloos
# 03-21-2003 Ivo Abeloos
# 06-12-2003	            use FPnic to get nic info
# 06-17-2003	            backwards issues
# 30-03-2005                new faro disknaming convention
# 14-03-2005                order of disks is important
# 15-03-2005 Ivo Abeloos    NIC probs TT18590
# 02-05-2005 Ivo Abeloos    use special CV report
# 07-10-2005 Ivo Abeloos    new server jar
#

# use method
use Time::Local;

our($color , $hostname, $red, $yellow);
our($threeSpc ,$sixSpc, $nineSpc, $newLine);

my ($DISK_NAME) = "disk_name";
my ($DISK_STATE)= "disk_state";

$color  	= "g";
$red    	= "";
$yellow 	= "";
$threeSpc 	= '   ';
$sixSpc 	= '      ';
$nineSpc 	= '            ';
$newLine 	= "\n";
$hostname 	= `cat /var/local/filepool/filepool.properties | grep HOSTNAME= `;
chomp($hostname);
($ignore, $hostname) = split('=', $hostname);

print '<node>'.$newLine;
print nics();
print disks();
print tasks();
print check_eth2();
upgrade_in_process();
# check_rangeShift(); -- removed by JB TT 11701
print colour();
set_complete();
print '</node>'.$newLine;

#
#
#
exit;

#
# the information is complete
#
sub set_complete
{
    print "${threeSpc}\<complete value = \"complete\" /\>\n";
}

#
# print color and reasons for yellow/ red
#
sub colour
{
    my ($output);

    $output =  $threeSpc.'<status color = "'.$color.'">'.$newLine;
    if ($color ne "g")
    {
        if ($yellow ne "")
        {
            $ouput	= $output.$threeSpc."<yellow>".$newLine;
            $output	= $output.$yellow;
            $ouput	= $output.$threeSpc."</yellow>".$newLine;
        }

        if($red ne "")
        {
            $ouput	= $output.$threeSpc."<red>".$newLine;
            $output	= $output.$red;
            $ouput	= $output.$threeSpc."</red>".$newLine;
        }
    }
    $output = $output.$threeSpc."</status>".$newLine;
    return $output;
}

#
# set the global color variable
#
sub set_color
{
    my ($setTo)	= @_[0];
    my ($reason)= @_[1];

    chomp($reason);
    if ($setTo eq "r")
    {
        $color = "r";
        if ($reason ne "")
        {
            $red = $red.$sixSpc.'<reason text = "'.$reason.'"';
            $red = $red." />".$newLine ;
        }
    }
    elsif (($setTo eq "y")&&($color ne "r"))
    {
        $color = "y";
        if ($reason ne "")
        {
            $yellow = $yellow.$sixSpc.'<reason text = "'.$reason.'"';
            $yellow = $yellow."/>".$newLine;
        }
    }
}

#
# check whether ethernets are up or not
#
sub nics()
{
    my($speed, $link, $netErr, $ifConfig, @ifConfLst);
    my($line, $output);
    my($output) = $threeSpc."<nics>".$newLine;

    #
    # get information of nics using FPnic tool
    #
	$output = $output . lookup_nics('eth0');
	$output = $output . lookup_nics('eth1');
	$output = $output . lookup_nics('eth2');

	$output = $output.$threeSpc."</nics>".$newLine;
	return $output;
}

#
# lookup_nics()
#
sub lookup_nics
{
	my ($iface) = @_;

	#
    # get nic configuration
	#
	my ($output) = "";
	my ($info)	 = "";
	my ($state, $speed, $link);

	if (-e '/sbin/FPnic')
	{
		$info = qx(/sbin/FPnic ${iface});
		chomp($info);
	    ($ignore, $state, $speed, $link) = split(':', $info);
	} else {
		$info = qx(/sbin/mii-tool ${iface});
		chomp($info);

		($ignore, $config) = split(':', $info);
        if ($config =~ /no link/)
        {
           $speed = "";
           $link = $config;
           $link =~ s/^ *//;
        } else {
           ($speed, $link) = split(',', $config);
           $speed =~ s/ *negotiated *//;
           $link =~ s/^ *//;
        }
	}

	#
    # get ip, state and error information
	#
    @ifConfLst = qx(ifconfig $iface);
    chomp(@ifConfLst);
    $ifConfig = join("#", @ifConfLst);
    $ifConfig =~ m/inet addr:([0-9.]*)/;
    $inet_addr = $1;
    if ($ifConfig =~ m/# {10}UP /) {
        $state = "UP";
        if ($ifConfig =~ m/ NOARP /) {
            $state = "DOWN";
	        set_color("y", $iface." is down");
        }
    } else {
      $state = "DOWN";
	  set_color("y", $iface." is down");
    }

	#
    # get net errors
	#
    my($out)	= qx(cat /proc/net/dev | grep $iface);
    my(@line)	= split(' ', $out);
    $netErr		= $line[3] + $line[11];

	#
    # process output
	#
    $output = $output.$sixSpc.'<nic name = "'.$iface.'"';
    $output = $output.$newLine.$nineSpc.'state = "'.$state.'"';
    $output = $output.$newLine.$nineSpc.'ip = "'.$inet_addr.'"';
    $output = $output.$newLine.$nineSpc.'link = "'.$link.'"';
    $output = $output.$newLine.$nineSpc.'speed = "'.$speed.'"';
    $output = $output.$newLine.$nineSpc.'errors = "'.$netErr.'"';
    $output = $output.$newLine.$sixSpc."/>".$newLine;

    return $output;
}

#
# check whether all disks are up or not (a big difference between from Gen4 onwards!)
#
sub disks
{
    my($output, $i, $ignore);
    my($device, $disk, $result);
    my($faro) = ( -e "/usr/local/bin/platformAPIReport.sh" );

    $output = $threeSpc.'<disks>'.$newLine;
    #
    # check presence of the platform report (gen4 criteria)
    #
    if ($faro) {
        my(@drives) = get_disk_status();
        my($counter) = 0;
        foreach $drive_info (@drives) {
            $output = $output.$sixSpc.'<disk name = "'. $drive_info->{$DISK_NAME} .'"';
            $output = $output.$newLine.$nineSpc.'status = "'. $drive_info->{$DISK_STATE} .'"';
            $output = $output.$newLine.$sixSpc.'/>'.$newLine;
            $counter = $counter + 1;
        }
    } else {
        for ($i=1; $i<=4; $i++) {
            $disk = "/mnt/blobs".$i;
            $result = qx(df -k $disk | grep $disk);
            my($totalsize, $used_size, $available_size , $perc_used);
            if ($result =~ m#^/#) {
                ($device,$totalsize,$used_size,$available_size,$perc_used)=split(' ',$result);
            } else {
                ($totalsize,$used_size,$available_size,$perc_used)=split(' ', $result);
            }
            $output = $output.$sixSpc.'<disk name = "'.'hd'.$i.'"';
            $output = $output.$newLine.$nineSpc.'status = "'.disk_status($i).'"';
            $output = $output.$newLine.$nineSpc.'usage = "'.$perc_used.'"';
            $output = $output.$newLine.$sixSpc.'/>'.$newLine;
            ($perc_used, $ignore) = split("%", $perc_used);
            #
            # set the color to yellow if disk used more than 90%
            #
            if ($perc_used >=  90) {
                set_color("y", " More than 90% of disk space used");
            }
        }
    }
    $output = $output.$threeSpc.'</disks>'.$newLine;
    return ($output);
}

#
# comes from fpdevice, reads the disk information (from Gen4 onwards)
#
sub get_disk_status {
    my (@drives);
    my ($drive_info);

    $command="export FILEPOOL_HOME=/home/filepool/FP/Lib;";
    $command=$command . "export LD_LIBRARY_PATH=\$FILEPOOL_HOME;";
    $command=$command . "export JAVA=`cat /home/filepool/FP/java`/bin/java;";
    $command=$command . "\$JAVA -cp \$FILEPOOL_HOME/commons-lang-2.0.jar:\$FILEPOOL_HOME/commons-lang-2.1-rc1.jar:\$FILEPOOL_HOME/commons-lang-2.1.jar:";
    $command=$command . "\$FILEPOOL_HOME/Filepool.zip:\$FILEPOOL_HOME/platforminterfaces.jar:\$FILEPOOL_HOME/platformapi.jar ";
    $command=$command . "com.filepool.platformsupport.report.PlatformAPIReportForCV";
    $platformAPI = `sh -c \'$command\'`;
    print DEBUG "$$: platform API returned: " . $platformAPI . "\n" if ($debug);
    my @disk_info=($platformAPI =~ /(\/dev\S+)\s+(\S+)/igs);

    my ($drive);
    my (@full_drive_names);
    for ($i=0; $i<=$#disk_info; $i=$i+2) {
        my ($realname) = {};
        $realname->{$DISK_NAME} = $disk_info[$i] . ":" . ($i / 2);
        $realname->{$DISK_STATE} = "offline";
        if (lc($disk_info[$i+1] eq "true")) {
            $realname->{$DISK_STATE} = "online";
        }
        push(@full_drive_names, $realname);
    }
    return (@full_drive_names);
}    # get_disk_status

#
# check the status of given disk
#
sub disk_status
{
    my($dsk, $args);
    my($stats) = "failed";

    $args = @_[0];
    if (($args >= 0) && ($args <= 4))
    {
        #
        # get avilable disks
        #
        my(@avail_dsks) = qx(ls /var/local/bootstat/DISK* 2> /dev/null | grep DISK);
        chomp(@avail_dsks);
        if ("1" eq $args)
        {
            $dsk =  search_disk("a" , "e" , @avail_dsks);
        } elsif ($args eq  "2")
        {
            $dsk =  search_disk("b" , "f" , @avail_dsks);
        } elsif ($args eq "3")
        {
            $dsk =  search_disk("c" , "g" , @avail_dsks);
        } elsif ($args eq "4")
        {
            $dsk =  search_disk("d" , "h" , @avail_dsks);
        }

        if ($dsk ne "")
        {

            #
            # find the status of the disk
            #
            $stats = qx(cat $dsk);
            if ($stats eq '')
            {
                set_color("y", "Disk ".$args." failed");
            } else {
                chomp($stats);
                if($stats eq "OK")
                {
                    $stats = "online";

                    #
                    # platform reports OK, check the filepool status
                    #
                    my($blobs_file) = "/var/local/bootstat/blobs".$args;
                    if (-e $blobs_file)
                    {
                        my($fp_status) = qx(cat $blobs_file);
                        chomp($fp_status);
                        if ($fp_status ne "")
                        {
                            if ($fp_status eq "Offline")
                            {
                                $stats = "offline";
                            } elsif ($fp_status ne "Online")
                            {
                                $stats = "failed";
                            } else {
                                $stats = "online";
                            }
                        } else {
                            $stats = "failed";
                        }
                    }
                } else {
                    $stats = "failed";
                }
                if ($stats eq "offline")
                {
                    set_color("y", "Disk ".$args." offline");
                }
                if ($stats eq "failed")
                {
                    set_color("y", "Disk ".$args." failed");
                }
            }
        }else{
                set_color("y", "Disk ".$args." not present");
        }
    }
    return ($stats);
}

#
# search whether a particular disk is existing or not
#
sub search_disk
{
    my($str1, $str2, @avail_dsks) = @_;

    $str1 = "/var/local/bootstat/DISK-".$str1."-STATUS";
    $str2 = "/var/local/bootstat/DISK-".$str2."-STATUS";
    foreach (@avail_dsks)
    {
        if(/$str1/)
        {
            return $_;
        } elsif(/$str2/)
        {
            return $_;
        }
    }
    return "";
}

#
# running tasks
#
sub tasks
{
    #
    # processes to be ignored to raise yellow flag
    #
    my @processArray    = ("UpdateLogProcess", "MD5VerifierTask", "ClipImporterTask", "NewOrganicRegenerator");
    my %ignoreProcesses = map {$_, $_ } sort(@processArray);
    my @logFiles;

    #
    # array temp holds list of log files
    #
    my ($text, %taskHash, $key, $value, $output, $file, $splitVar);
    my ($term, $ignore);

    #
    # for processing the lines
    #
    my ($startDate, $startTime, $taskStartTime, $taskStartTimeStr);
    my ($logDate);

    my $taskStr  = "TaskStarted";
    my $taskStop = "TaskStopped";
    my $logFile  = "Log File Created";

    @logFiles = ` ls -c -1 /var/local/filepool/Logfiles/FilePool_Log_*.log 2> /dev/null `;
    chomp (@logFiles);
    foreach $file(@logFiles)
    {
        open(filePtr, $file) || set_color("y", "Can not open file: ".$file);
        $text = <filePtr>;
        while ($text)
        {
            chomp ($text);
            #
            # if line contains time take as start time
            #
            if ($text =~ /\b$logFile\b/)
            {
                ($ignore, $logDate) = split("at ", $text);
                ($logDate, $ignore) = split(" ", $logDate);
            }

            if ($text =~ /\b$taskStr\b/)
            {
                #
                # process to see whether process started or stopped.
                #
                ($ignore, $term)= split('\[',$text);
                ($term, $ignore)= split('\]',$term);

                chomp($term);
                if ($term ne "")
                {
                    if (!exists $ignoreProcesses{$term})
                    {
                        ($splitVar, $ignore) = split(" ",$text);
                        $taskHash{$term} = $logDate.":".$splitVar;
                    }
                }
            }
            if ($text =~ /\b$taskStop\b/)
            {
                ($ignore, $term)= split('\[',$text);
                ($term, $ignore)= split('\]',$term);

                chomp($term);
                if ($term ne "")
                {
                    if (!exists $ignoreProcesses{$term})
                    {
                        if (exists $taskHash{$term})
                        {
                            #
                            # remove task entry - assume next entry is timestamped later
                            #
                            delete $taskHash{$term};
                        }
                    }
                } else {
                    #
                    # ignore stopped tasks when no preceeding start entries.
                    #
                }
            }
            $text = <filePtr>;
        }
        close (filePtr);
    }
    #
    # print all remaining entries in start array.
    #
    foreach $key (keys %taskHash)
    {
        ($startDate, $startTime) = split(':', $taskHash{$key});
        $taskStartTimeStr = $startDate." ".$startTime;

        $output = $output.$sixSpc.'<task name = "'.$key.'" ';
        $output = $output.'starttime = "'.$taskStartTimeStr.'"/>';
        $output = $output.$newLine;

        set_color("y", $key." is not yet stopped");
    }

    #
    # add tasks xml tags
    #
    if ($output =~ /task/)
    {
        $output = $threeSpc."<tasks>".$newLine.$output;
        $output = $output.$threeSpc."</tasks>".$newLine;
    }
    return $output;
}

#
# if this node is front end, check whether eth2 is avilable
#
sub check_eth2
{
    $isFront = `cat /var/local/filepool/filepool.properties | grep FRONTEND=true`;
    chomp ($isFront);
    if(isFront eq "FRONTEND=true")
    {
        my ($eth2, $ignore, $ping,  $cmd);
        ($eth2, $ignore) =  split("n", $hostname);
        $eth2 = $eth2."sw0";
        $cmd = 'ping -c 4 '.$eth2.' 2>&1 | grep "unknown host"' ;
        open(CMD, "$cmd |");
        $ping = <CMD>;
        close(CMD);
        if( $ping =~ /unknown host/)
        {
            set_color("r", "Eth2 is down");
        }
    }
}

#
# check if range shifting is taking place
#
sub check_rangeShift
{
    my $nodeId = `grep $hostname  /var/local/filepool/ClusterManager/NodeParams/*.cml`;

    ($ignore, $nodeId) = split("NodeParams\/", $nodeId);
    ($nodeId, $ignore) = split(".cml", $nodeId);

    #
    # get range operations on this node
    #
    my(@rangeOp) = `cat /var/local/filepool/ClusterManager/ClusterParams/StorageServer_range.cml | grep node  | grep $nodeId ` ;
    chomp(@rangeOp);

    my $temp = "g";
    foreach $line(@rangeOp)
    {
        if(($line =~ /updatingnode/) ||
            ($line =~ /initnode/) ||
        ($line =~ /incompletenode/))
        {
            $temp = "y";
        }
    }
    if ( $temp eq "y")
    {
        set_color("y", "Range Shift is taking place");
    }
}

#
# check whether upgrade is in process.
#
sub upgrade_in_process
{
    my ($result, $a_files , $d_files,  $cmd);

    #
    # get Activation files that does not end with complete - to check upgrade.
    #
    $cmd = "/var/local/bootstat/A* 2> /dev/null | grep -1 ACTIVATION | grep $hostname | grep -v COMPLETE ";
    $a_files = `ls $cmd  2> /dev/null `;
    chomp($a_files);
    #
    # check D* files other than DISK - to see upgrade is going.
    #
    $d_files  = `ls /var/local/bootstat/D* 2> /dev/null | grep -v DISK`;
    chomp($d_files);
    if (($a_files ne '')&&($d_files ne ''))
    {
        set_color("y", "Upgrade in process");
    }
}
