#
# range_xml.pl
#
# abeloos_ivo@emc.com
#

my ($configuration)	= "\/var\/local\/filepool\/ClusterManager\/ClusterParams\/StorageServer_range.cml";
my ($xml)		= "\<range_status\>";

my ($result) = open(RANGE_CML, $configuration);
if ($result == 1)
{
	my ($range) = 0;
	my ($nodes) = 0;

	while (<RANGE_CML>)
	{
		my ($line) = $_;

		#
		# trim
		#
		$line =~ s/^(\s*)//g;
		$line =~ s/(\s*)$//g;

		#
		#
		#
		if ($line =~ /^\<range status=\"(\S+)\" start=\"(\S+)\" end=\"(\S+)\"/)
		{
			if ($range == 1)
			{
				if ($nodes == 1)
				{
					$xml	= $xml . "\n\</nodes\>";
					$nodes	= 0;
				}
				$xml	= $xml . "\n\</range\>";
				$range	= 0;
			}
			#
			# a new range
			#
			$xml	= $xml . "\n\<range status=\"$1\" start=\"$2\" end=\"$3\" \>";
			$range	= 1;
		}

		#
		# node
		#
		if ($line =~ /^\<node id=\"(\S+)\"/)
		{
			if ($nodes == 0)
			{
				$xml	= $xml . "\n\<nodes\>";
				$nodes	= 1;
			}

			my ($id)	= $1;
			my ($result)	= `cat \/var\/local\/filepool\/ClusterManager\/NodeParams\/${id}\.cml \| grep HOSTNAME`;
			my ($name)	= $id;
			if ($result =~ /value=\"(\S+)\"/)
			{
				$name = $1;
			}
			$xml		= $xml . "\n\<node id=\"$id\" name=\"$name\" /\>";
		}

		#
		# incomplete node
		#
		if ($line =~ /^\<incompletenode id=\"(\S+)\"/)
		{
			$xml = $xml . "\n" . $line;
		}

		#
		# updating node
		#
		if ($line =~ /^\<updatingnode id=\"(\S+)\"/)
		{
			$xml = $xml . "\n" . $line;
		}

		#
		# init node
		#
		if ($line =~ /^\<initnode id=\"(\S+)\"/)
		{
			$xml = $xml . "\n" . $line;
		}

		#
		# shiftnode node
		#
		if ($line =~ /^\<shiftnode id=\"(\S+)\" start=\"(\S+)\" end=\"(\S+)\"/)
		{
			$xml = $xml . "\n" . $line;
		}

		#
		# repairnode node
		#
		if ($line =~ /^\<repairnode id=\"(\S+)\" start=\"(\S+)\" end=\"(\S+)\" targetnodeid=\"(\S+)\"/)
		{
			$xml = $xml . "\n" . $line;
		}
	}
	if ($range == 1)
	{
		if ($nodes == 1)
		{
			$xml	= $xml . "\n\</nodes\>";
			$nodes	= 0;
		}
		$xml = $xml . "\n\<\/range\>";
		$range = 0;
	}
	close(RANGE_CML);
}

$xml = $xml . "\n\</range_status\>";
$xml = $xml . "\n";

print $xml;
